#include "Tau.h"
int SEDMap()
{
    TCanvas *c1=new TCanvas("c1","",1500,600);
      c1->SetFillColor(10);
      c1->SetFrameFillColor(10);
      c1->SetLogy(1);
      c1->SetLogx(1);
      c1->SetFillStyle(0);
     gStyle->SetFillColor(10);
     gStyle->SetFrameFillColor(10);
     gStyle->SetStatColor(10);
     gStyle->SetStatTextColor(2);
     gStyle->SetPalette(1);
     gStyle->SetOptFit(0);
     TGraph *g[20];
     int i,j,k,n;
     double chi,x[100],y[100];
     char sTemp[300];
    x[0]=10;y[0]=2.e-11;
    x[1]=1.e3;y[1]=1.e-14;
    g[0]=new TGraph(2,x,y);

    g[1]=ReadSED("J2228_KM2A_201209.dat",20,2,1);
    g[4]=ReadSED("J2228_KM2A_201209.dat",20,2,1);
    g[2]=ReadSED("J1908_KM2A_201209.dat",20,2,1);
    g[5]=ReadSED("J1908_KM2A_201209.dat",20,2,1);
    g[3]=ReadSED("J1825_KM2A_201209.dat",20,2,1);
    g[6]=ReadSED("J1825_KM2A_201209.dat",20,2,1);
    c1->Clear();

    gBenchmark->Start("canvas");
    TPad *pad1,*pad2,*pad3;
    pad1 = new TPad("pad1","This is pad1",0.02,0.01,0.37,0.99);
    pad2 = new TPad("pad2","This is pad2",0.365,0.01,0.67,0.99);
    pad3 = new TPad("pad3","This is pad2",0.67,0.01,0.99,0.99);

    pad1->SetFillColor(10);  pad1->Draw();
    pad2->SetFillColor(10);  pad2->Draw();
    pad3->SetFillColor(10);  pad3->Draw();

    pad1->cd();
    gPad->SetLeftMargin(0.15);
    gPad->SetRightMargin(0.001);
    gPad->SetFillColor(10);
    gPad->SetFrameFillColor(10);
    gPad->SetLogy(1);
    gPad->SetLogx(1);
    g[0]->SetMarkerColor(10);
    g[0]->SetLineColor(10);
    g[0]->Draw("AP");
    g[7]=GetTauTG("tau_2227.dat",g[4],15,600);
    g[7]->Draw("L");
    g[1]->Draw("PZ");
    g[4]->Draw("PZ");
     TF1 *f=new TF1("f","[0]*pow(x/20.0,[1])*pow(x,2)",10,2000);
      f->SetParameters(1.5e-11,-2.4);
      f->SetLineColor(1);
      f->SetLineWidth(2);
      f->SetLineStyle(2);
      f->SetParNames("J_{20TeV}","#alpha");
      g[1]->Fit(f,"","",15,600);

      TF1 *f2=new TF1("f2","[0]*pow(x/20.,[1]+[2]*log10(x/20.))*pow(x,2)");
      f2->SetParameters(2.e-14,-2.6,-0.2,1000);
      f2->SetLineColor(1);
      f2->SetLineWidth(2);
      f2->SetParNames("J_{20TeV}","#alpha","b");
     g[4]->Fit(f2,"","",15,600);
     g[0]->SetTitle(";Energy (TeV); E^{2}dN/dE (erg cm^{-2} s^{-1})");
     g[0]->GetYaxis()->CenterTitle(true);
     g[0]->GetYaxis()->SetTitleOffset(1.4);
     g[0]->GetXaxis()->SetTitleOffset(1.);
     g[0]->GetXaxis()->SetTitleSize(0.05);
     g[0]->GetXaxis()->CenterTitle(true);
     g[0]->GetYaxis()->SetTitleSize(0.05);
     g[0]->GetYaxis()->SetRangeUser(1.e-14,3.e-11);
     g[0]->GetXaxis()->SetRangeUser(10,1100);
    TLatex *tex=new TLatex(100,1.e-11,"LHAASO J2226+6057");
    tex->SetTextSize(0.04);
    tex->Draw();

    pad2->cd();
   gPad->SetLeftMargin(0.001);
   gPad->SetRightMargin(0.001);
   gPad->SetFillColor(10);
   gPad->SetFrameFillColor(10);
   gPad->SetLogy(1);
   gPad->SetLogx(1);
     g[0]->Draw("AP");
     g[8]=GetTauTG("tau_1908.dat",g[5],10,600);
     g[8]->Draw("L");
     g[2]->Draw("PZ");
     g[5]->Draw("PZ");
     g[2]->Fit(f,"","",10,600);
     g[5]->Fit(f2,"","",10,600);  
   tex=new TLatex(100,1.e-11,"LHAASO J1908+0621");
    tex->SetTextSize(0.04);
    tex->Draw();
    pad3->cd();
     gPad->SetLeftMargin(0.001);
   gPad->SetFillColor(10);
   gPad->SetFrameFillColor(10);
   gPad->SetLogy(1);
   gPad->SetLogx(1);
     g[0]->Draw("AP");
     g[9]=GetTauTG("tau_1825.dat",g[6],25,600);
     g[9]->Draw("L");
     g[3]->Draw("PZ");
     g[6]->Draw("PZ");
     g[3]->Fit(f,"","",25,600);
     g[6]->Fit(f2,"","",25,600);
   tex=new TLatex(100,1.e-11,"LHAASO J1825-1326");
    tex->SetTextSize(0.04);
    tex->Draw();

    TPad *pd1,*pd2,*pd3;
    pd1 = new TPad("pd1","This is pad1",0.18,0.15,0.62,0.55);
    pd2 = new TPad("pd2","This is pad2",0.02,0.15,0.53,0.55);
    pd3 = new TPad("pd3","This is pad2",0.02,0.15,0.5,0.55);
    pad1->cd();
    pd1->SetFillColor(10);  pd1->Draw();
    gStyle->SetOptStat(0);
    pad2->cd();
    pd2->SetFillColor(10);  pd2->Draw();
    pad3->cd();
    pd3->SetFillColor(10);  pd3->Draw();

    TFile *file[20]; TH2F *h2h[20];
    file[2]=new TFile("SkymapJ1825.root");
    file[1]=new TFile("SkymapJ1908.root");
    file[0]=new TFile("SkymapJ2228.root");

    Int_t MyPalette[100];
       Double_t r[5]    = {0., 0.0, 1.0, 1.0, 1.0};
       Double_t gr[5]    = {0., 0.0, 0.0, 1.0, 1.0};
       Double_t b[5]    = {0., 1.0, 0.0, 0.0, 1.0};
       Double_t stop[5] = {0., 0.5, 0.7, 0.9, 1.0};
       Int_t FI = TColor::CreateGradientColorTable(5, stop, r, gr, b, 100);
       for (i=0;i<100;i++){
          MyPalette[i] = FI+i;
       }  
       gStyle->SetPalette(100, MyPalette);

    double w,w2;
    w=2;
    w=1.25;
    double Ra[5]={336.846,286.992,276.427};
    double Dec[5]={60.941,6.339,-13.457};
    double R[5]={0.325,0.297,0.403};
    TEllipse *ellipse;
    for(i=0;i<3;i++){
       printf("%d\n",i);
       if(i==0)pd1->cd();
       if(i==1)pd2->cd();
       if(i==2)pd3->cd();
       w2=w/cos(Dec[i]/57.3);
       h2h[i]=(TH2F*)file[i]->Get("h2");
       h2h[i]->Draw("colz");
       h2h[i]->SetContour(100);
       h2h[i]->SetMaximum(20);
       h2h[i]->SetMinimum(-4);
       h2h[i]->GetXaxis()->SetRangeUser(Ra[i]-w2,Ra[i]+w2);
       h2h[i]->GetYaxis()->SetRangeUser(Dec[i]-w,Dec[i]+w);
       h2h[i]->GetYaxis()->CenterTitle(true);
       h2h[i]->GetXaxis()->CenterTitle(true);
       h2h[i]->GetXaxis()->SetNdivisions(505);
       h2h[i]->GetYaxis()->SetNdivisions(505);
       h2h[i]->GetYaxis()->SetTitleOffset(1.12);
       h2h[i]->GetYaxis()->SetTitleSize(0.045);
       h2h[i]->GetXaxis()->SetTitleSize(0.045);
       h2h[i]->SetTitle(";Right ascension ; Declination");
       ellipse = new TEllipse(Ra[i]+w2*3/5.,Dec[i]-w*3/5.,R[i]*1.51/cos(Dec[i]/57.3),R[i]*1.51,0,360,0);
       ellipse->SetFillStyle(0); ellipse->SetLineWidth(2);
       ellipse->SetLineColor(3);
       ellipse->Draw();
       c1->Update();
    }
    
   return 0;
}

