TGraph * ReadSED(const char file[200],int ns, int nc, double size){
   ifstream file1;
   file1.open(file);
   char sTemp[200];
   TGraph *g;
   double energy,flux,err1,err2,x[200],ex[200],y[200],ey1[200],ey2[200];
   int i,n=0;
   while(file1.good()){
        file1.getline(sTemp,200);
        i=sscanf(sTemp,"%lf %lf %lf %lf",&energy,&flux,&err2,&err1);
        if(i>1){
             if(flux/err1<1)continue;
            x[n]=energy/1.e12; ex[n]=0;
            y[n]=flux;
            ey1[n]=err1;
            if(i>3)ey2[n]=err2;
            else ey2[n]=err1;
            n++;
        }
        if(n>200)printf("n>200\n");
   }
   file1.close();
   g=new TGraphAsymmErrors(n,x,y,ex,ex,ey1,ey2);
   g->SetMarkerStyle(ns);
   g->SetMarkerColor(nc);
   g->SetMarkerSize(size);
   g->SetLineColor(nc);
   g->SetLineWidth(2);

   return g;
}
int ReadTau(const char file[200],double *x){
   ifstream file1;
   file1.open(file);
   char sTemp[200];
   double energy,flux,err1,err2;
   int i,n=0;
   while(file1.good()){
        file1.getline(sTemp,200);
        i=sscanf(sTemp,"%lf %lf %lf %lf",&x[n],&x[n+1],&x[n+2],&x[n+3]);
        if(i>0)n +=i;
   }
   file1.close();
   return n;
}
double GetTau(double *x, double *y, double energy){
   int i;
   for(i=0;i<221;i++){
         if(energy<x[i])break;
   }
   return (energy-x[i-1])/(x[i]-x[i-1])*(y[i]-y[i-1])+y[i-1];
}
TGraph * GetTauTG(const char file[200],TGraph *gg,double Emin,double Emax){
   double e,T[250],E[250],x[250],y[250];
   int i;
   char sTemp[300];
   double de=(log10(Emax)-log10(Emin))/100.;
   TF1 *f=new TF1("f","[0]*pow(x/20.,[1]+[2]*log10(x/20.))");
   f->SetParameters(2.e-14,-0.6,-0.2);
   gg->Fit(f,"","",10,600);
   double p0=f->GetParameter(0);
   double p1=f->GetParameter(1);
   double p2=f->GetParameter(2);
   ReadTau("./SED/en.txt",E);
   ReadTau(file,T); 
   for(i=0;i<100;i++){
       e=pow(10,log10(Emin)+de*i);
       x[i]=e;
       y[i]=p0*pow(x[i]/20.,p1+p2*log10(x[i]/20.))/exp(-GetTau(E,T,e*1.e12));
   }
   TGraph *g;
   g=new TGraph(100,x,y);
   g->SetLineStyle(3);
   g->SetLineWidth(2);
   return g;
}
